# Create and manage shift inputs

> Fetch and manage shift inputs used in Time & Attendance time entries.

## Overview

Shift inputs are used to add additional information to Time & Attendance time entries pertaining to the work performed or the conditions under which the work was performed.

Some examples include:

-   The number of miles an employee drove.
-   Issues the employee encountered during their shift.
-   The type of equipment the employee used during their shift.

### Available endpoints

| Endpoint | Description |
| --- | --- |
| [GET List shift inputs](https://developer.rippling.com/documentation/rest-api/reference/list-shift-inputs) | Lists existing shift inputs. |
| [POST Create a new shift input](https://developer.rippling.com/documentation/rest-api/reference/create-shift-inputs) | Creates a new shift input. `name`, `prompt`, `type`, and `country_code` are required. |
| [GET Retrieve a specific shift input](https://developer.rippling.com/documentation/rest-api/reference/get-shift-inputs) | Retrieves a shift input by `id`. |
| [PATCH Update a shift input](https://developer.rippling.com/documentation/rest-api/reference/update-shift-inputs) | Updates a shift input. |
| [DELETE Delete a shift input](https://developer.rippling.com/documentation/rest-api/reference/delete-shift-inputs) | Deletes a shift input. |

Related endpoints:

| Endpoint | Description |
| --- | --- |
| [POST Create a new time entry](https://developer.rippling.com/documentation/rest-api/reference/create-time-entries) | Creates a new time entry. |

### Suggested workflow

1.  [Create a new shift input](https://developer.rippling.com/documentation/rest-api/reference/create-shift-inputs) with `name`, `prompt`, `type`, and `country_code`.
2.  [Fetch the new shift input](https://developer.rippling.com/documentation/rest-api/reference/list-shift-inputs) and note the `id`.
3.  [Create a new time entry](https://developer.rippling.com/documentation/rest-api/reference/create-time-entries) and set `shift_input_values[].shift_input_id` to the new shift input `id`. Time entries can be modified until finalized, with the appropriate admin permissions.

* * *

## Requirements

-   The Rippling API SKU
-   An API token with the following scopes:
    -   `shift-inputs.read` to fetch shift inputs
    -   `shift-inputs.read-write` to create or update shift inputs
    -   `time-entries.read-write` to create a new time entry

* * *

## Fetch

Use [GET List shift inputs](https://developer.rippling.com/documentation/rest-api/reference/list-shift-inputs) to return a list of shift inputs.

_Request:_

```json
curl -L -X GET 'https://rest.ripplingapis.com/shift-inputs/'
-H 'Accept: application/json'
-H 'Authorization: Bearer REDACTED'
```

_Response:_

```json
{
  "__meta": {
    "redacted_fields": []
  },
  "results": [
    {
      "id": "66b26001a91aca1dfb199301",
      "created_at": "2026-03-17T21:37:32.953000+00:00",
      "updated_at": "2026-03-17T21:37:32.953000+00:00",
      "creator_id": "58d3a1f0e4b0a12c3d456789",
      "creator": null,
      "name": "Miles driven",
      "prompt": "How many miles did you drive?",
      "type": "number",
      "country_code": "US",
      "managed_by": null
    }
  ],
  "next_link": null
}
```

| Response body fields | Description |
| --- | --- |
| `id` | Shift input identifier. Use this as `shift_input_id` on a time entry. |
| `created_at` | When the shift input was created. |
| `updated_at` | When the shift input was last updated. |
| `creator_id` | Worker who created the shift input. |
| `creator` | Worker object. Returned when the request uses `expand=creator`. Otherwise null. |
| `name` | Name of the shift unit. |
| `prompt` | Prompt shown for the shift unit. |
| `type` | Type of shift unit. Must be 'NUMBER', 'TEXT', 'BOOLEAN', or 'LIST'. |
| `country_code` | Two-letter country code for this shift input. |
| `managed_by` | Party that manages this shift input. |

Use [GET Retrieve a specific shift input](https://developer.rippling.com/documentation/rest-api/reference/get-shift-inputs) when you already have the shift input id.

* * *

## Create

Use [POST Create a new shift input](https://developer.rippling.com/documentation/rest-api/reference/create-shift-inputs) to create a new shift input.

_Request:_

```json
curl -L -X POST 'https://rest.ripplingapis.com/shift-inputs/'
-H 'Accept: application/json'
-H 'Content-Type: application/json'
-H 'Authorization: Bearer REDACTED'
```

_Request body:_

```json
{
  "name": "Miles driven",
  "prompt": "How many miles did you drive?",
  "type": "number",
  "country_code": "US",
  "creator_id": "58d3a1f0e4b0a12c3d456789"
}
```

| Request body fields | Required | Description |
| --- | --- | --- |
| `name` | Yes | Name of the shift input. |
| `prompt` | Yes | Prompt for the employee. |
| `type` | Yes | Type of shift input. Must be 'NUMBER', 'TEXT', 'BOOLEAN', or 'LIST'. |
| `country_code` | Yes | Two-letter country code. |
| `creator_id` | No | Worker who created the shift input. |

_Response:_

```json
{
  "id": "66b26001a91aca1dfb199301",
  "created_at": "2026-03-17T21:37:32.953000+00:00",
  "updated_at": "2026-03-17T21:37:32.953000+00:00",
  "creator_id": "58d3a1f0e4b0a12c3d456789",
  "creator": null,
  "name": "Miles driven",
  "prompt": "How many miles did you drive?",
  "type": "number",
  "country_code": "US",
  "managed_by": null
}
```

* * *

## Update

Use [PATCH Update a shift input](https://developer.rippling.com/documentation/rest-api/reference/update-shift-inputs) to modify an existing shift input. No fields are required, and include only the fields you are changing in the request body.

_Request:_

```json
curl -L -X PATCH 'https://rest.ripplingapis.com/shift-inputs/66b26001a91aca1dfb199301/'
-H 'Accept: application/json'
-H 'Content-Type: application/json'
-H 'Authorization: Bearer REDACTED'
```

_Request body:_

```json
{
  "prompt": "Enter the miles driven during this shift."
}
```

_Response:_

```json
{
  "id": "66b26001a91aca1dfb199301",
  "created_at": "2026-03-17T21:37:32.953000+00:00",
  "updated_at": "2026-03-18T15:04:11.120000+00:00",
  "creator_id": "58d3a1f0e4b0a12c3d456789",
  "creator": null,
  "name": "Miles driven",
  "prompt": "Enter the miles driven during this shift.",
  "type": "number",
  "country_code": "US",
  "managed_by": null
}
```

* * *

## Delete

Use [DELETE Delete a shift input](https://developer.rippling.com/documentation/rest-api/reference/delete-shift-inputs) to remove a shift input. If a time entry is deleted, the shift input still exists.

_Request:_

```json
curl -L -X DELETE 'https://rest.ripplingapis.com/shift-inputs/66b26001a91aca1dfb199301/'
-H 'Accept: application/json'
-H 'Authorization: Bearer REDACTED'
```

A successful delete returns `200` and no body.

* * *

## See also

-   [Get started with the Time API](https://developer.rippling.com/documentation/rest-api/guides/time-getting-started)
-   [Set up a shift input](https://help.rippling.com/article?articleId=149197459024)
-   [API tokens and permissions](https://developer.rippling.com/documentation/rest-api/essentials/api-tokens)

Source: https://developer.rippling.com/documentation/rest-api/guides/shift-inputs

> For the complete documentation index, see [llms.txt](https://developer.rippling.com/llms.txt). Public pages have a Markdown version at the same URL with .md added.
